#include "html.h"

void ids_error_report(gpointer key, gpointer value, gpointer data)
{
  int linha;
  linha=*(int*)value;
  if (linha<0)
    g_warning("Linha %d: Referencia a identificador nao declarado: %s",
	      -linha,((GString*)key)->str);
}

void _travessia_Html(Elem* el) {
  GHashTable* ids;
  HTMLF.inHEAD=0;
  HTMLF.inFECHO=0;
  HTMLF.TamTitulo=1;
  HTMLF.IndiceCount=0;
  ids=g_hash_table_new(Gstr2int,Compgstr);
  travessia_Html(el,ids);
  g_hash_table_foreach(ids,ids_error_report,NULL);
}

void travessia_Html(Elem* el,GHashTable* ids){
  if(el)
    {
      if(el->tipo==texto)
	{
	  GString* z=poe_acentos(Elem_texto_get(el));
	  printf("%s\n",z->str);
	  g_string_free(z,TRUE);
	}
      else
	Tipo_to_Html(el,ids);
      travessia_Html(el->next,ids);
    }
}

void travessia_Indice(Elem* el){
  if(el)
    {
      if(el->tipo!=texto)
	{
	  if (el->tipo==CAPITULO)
	    {
	      GString* z;
	      z=poe_acentos(Elem_texto_get(el->content->content));
	      printf("<LI><A HREF=\"#_indice%d\">%s</A><BR>\n",HTMLF.IndiceCount,z->str);
	      ++HTMLF.IndiceCount;
	      g_string_free(z,TRUE);
	      printf("<OL>\n");
	      travessia_Indice(el->content);
	      printf("</OL>\n");
	    }
	  else if (el->tipo==SECCAO)
	    {
	      GString* z;
	      z=poe_acentos(Elem_texto_get(el->content->content));
	      printf("<LI><A HREF=\"#_indice%d\">%s</A><BR>\n",HTMLF.IndiceCount,z->str);
	      ++HTMLF.IndiceCount;
	      g_string_free(z,TRUE);
	      printf("<OL>\n");
	      travessia_Indice(el->content);
	      printf("</OL>\n");
	    }
	  else
	    travessia_Indice(el->content);
	}
      travessia_Indice(el->next);
    }
}

GString* poe_acentos(GString* str)
{
  /*****************/
  /* ,[cC]         */
  /* '[aeiouAEIOU] */
  /* `[aeiouAEIOU] */
  /* ^[aeoAEO]     */
  /* ~[aeoAEO]     */
  /*****************/
  int tamanho=0;
  char* ptr;
  GString* new=g_string_new("");

  ptr=str->str;
  while(tamanho<str->len) {
    switch(*ptr) {
    case '':
      new=g_string_append(new,"&atilde;");
      ptr++;
      break;
    case '':
      new=g_string_append(new,"&otilde;");
      ptr++;
      break;
    case '':
      new=g_string_append(new,"&acirc;");
      ptr++;
      break;
    case '':
      new=g_string_append(new,"&ecirc;");
      ptr++;
      break;
    case '':
      new=g_string_append(new,"&icirc;");
      ptr++;
      break;
    case '':
      new=g_string_append(new,"&ocirc;");
      ptr++;
      break;
    case '':
      new=g_string_append(new,"&ucirc;");
      ptr++;
      break;
    case '':
      new=g_string_append(new,"&aacute;");
      ptr++;
      break;
    case '':
      new=g_string_append(new,"&eacute;");
      ptr++;
      break;
    case '':
      new=g_string_append(new,"&iacute;");
      ptr++;
      break;
    case '':
      new=g_string_append(new,"&oacute;");
      ptr++;
      break;
    case '':
      new=g_string_append(new,"&uacute;");
      ptr++;
      break;
    case '':
      new=g_string_append(new,"&agrave;");
      ptr++;
      break;
    case '':
      new=g_string_append(new,"&egrave;");
      ptr++;
      break;
    case '':
      new=g_string_append(new,"&igrave;");
      ptr++;
      break;
    case '':
      new=g_string_append(new,"&ograve;");
      ptr++;
      break;
    case '':
      new=g_string_append(new,"&ugrave;");
      ptr++;
      break;
    case ',':
      ptr++;
      switch(*ptr) {
      case 'c':
      case 'C':
	new=g_string_append_c(new,'&');
	new=g_string_append_c(new,*ptr);
	new=g_string_append(new,"cedil;");
	ptr++;
	break;
      default:
	new=g_string_append_c(new,',');
      }
      break;
    case '\'':
      ptr++;
      switch(*ptr) {
      case 'a':
      case 'e':
      case 'i':
      case 'o':
      case 'u':
      case 'A':
      case 'E':
      case 'I':
      case 'O':
      case 'U':
	new=g_string_append_c(new,'&');
	new=g_string_append_c(new,*ptr);
	new=g_string_append(new,"acute;");
	ptr++;
	break;
      default:
	new=g_string_append_c(new,'\'');
      }
      break;
    case '`':
      ptr++;
      switch(*ptr) {
      case 'a':
      case 'e':
      case 'i':
      case 'o':
      case 'u':
      case 'A':
      case 'E':
      case 'I':
      case 'O':
      case 'U':
	new=g_string_append_c(new,'&');
	new=g_string_append_c(new,*ptr);
	new=g_string_append(new,"grave;");
	ptr++;
	break;
      default:
	new=g_string_append_c(new,'`');
      }
      break;
    case '^':
      ptr++;
      switch(*ptr) {
      case 'a':
      case 'e':
      case 'o':
      case 'A':
      case 'E':
      case 'O':
	new=g_string_append_c(new,'&');
	new=g_string_append_c(new,*ptr);
	new=g_string_append(new,"circ;");
	ptr++;
	break;
      default:
	new=g_string_append_c(new,'^');
      }
      break;
    case '~':
      ptr++;
      switch(*ptr) {
      case 'a':
      case 'e':
      case 'o':
      case 'A':
      case 'E':
      case 'O':
	new=g_string_append_c(new,'&');
	new=g_string_append_c(new,*ptr);
	new=g_string_append(new,"tilde;");
	ptr++;
	break;
      default:
	new=g_string_append_c(new,'~');
      }
      break;
    default:
      new=g_string_append_c(new,*ptr);
      ptr++;
    }  
    tamanho++;
  }
  return new;
}

GHashTable* trata_id_html(GHashTable* hash,GHashTable* ids,int linha)
{
  GString *str;	
  void* ptr;
  str=g_hash_table_lookup(hash,g_string_new("id"));  
  if (str) {
    printf("<A NAME=\"%s\">\n",str->str);
    if (ptr=g_hash_table_lookup(ids,str)) 
      if ((*(int*)ptr)>0)
	g_warning("linha %d: Identificador %s definido anteriormente na linha %d.",
		  linha-1,str->str, *(int*)ptr -1 );
      else
	*(int*)ptr=linha;
    else
      {
	int* i;
	i=(int*)malloc(sizeof(int));
	*i=linha;
	g_hash_table_insert(ids,g_string_new(str->str),i);
      }
  }
  return ids;
}

void Tipo_to_Html(Elem* el,GHashTable* ids){
  char* str;

  unsigned int tipo;
  GHashTable* hash;
  Elem* filho;

  tipo=el->tipo;
  hash=el->hash;
  filho=el->content;

  switch(tipo)
    {
    case texto:
      break;
    case PLI_DOC:
      printf("<HTML>\n");
      ids=trata_id_html(hash,ids,el->nlinha);
      travessia_Html(filho,ids);
      printf("</HTML>\n");
      break;
    case ABERTURA:  
      printf("<HEAD>\n");
      ids=trata_id_html(hash,ids,el->nlinha);
      HTMLF.inHEAD=1;
      travessia_Html(filho,ids);
      printf("<H1><HR>&Iacute;ndice</H2>\n");
      printf("<OL>\n");
      travessia_Indice((el->next)->content);
      HTMLF.IndiceCount=0;
      printf("</OL>\n");
      break;
    case TITULO:
      if (HTMLF.inHEAD) {
	printf("<TITLE>\n");
	ids=trata_id_html(hash,ids,el->nlinha);
	travessia_Html(filho,ids);
	printf("</TITLE>\n");
	HTMLF.inHEAD=0;
	printf("</HEAD>\n");
	printf("<BODY>\n");
	printf("<H1>\n");
       	travessia_Html(filho,ids);
	printf("</H1>\n");
      } else {
	printf("<H%d>\n",(HTMLF.TamTitulo>6)?6:HTMLF.TamTitulo);
	ids=trata_id_html(hash,ids,el->nlinha);
	travessia_Html(filho,ids);
	printf("</H%d>\n",(HTMLF.TamTitulo>6)?6:HTMLF.TamTitulo);
      }       
      break;
    case DATA:
      printf("<H3>\n");
      ids=trata_id_html(hash,ids,el->nlinha);
      travessia_Html(filho,ids);
      printf("</H3>\n");
      break;
    case AUTOR:
      ids=trata_id_html(hash,ids,el->nlinha);
      travessia_Html(filho,ids);
      break;
    case NOME:
      printf("<H2>\n");
      ids=trata_id_html(hash,ids,el->nlinha);
      travessia_Html(filho,ids);
      printf("</H2>\n");
      break;
    case EMAIL:
      printf("E-mail: <A HREF=\"mailto:");
      travessia_Html(filho,ids);
      printf("\">\n");
      ids=trata_id_html(hash,ids,el->nlinha);
      travessia_Html(filho,ids);
      printf("</A><BR>\n");
      break;
    case URL:
      printf("Home page: <A HREF=\"");
      travessia_Html(filho,ids);
      printf("\">\n");
      ids=trata_id_html(hash,ids,el->nlinha);
      travessia_Html(filho,ids);
      printf("</A><BR>\n");
      break;
    case RESUMO:
      printf("<P><B>Resumo:</B></P>\n");
      ids=trata_id_html(hash,ids,el->nlinha);
      travessia_Html(filho,ids);
      break;
    case REALCADO:
      {
	GString *str, *str2;	
	str=g_hash_table_lookup(hash,g_string_new("estilo"));
	if (str) g_string_down(str);
	if(!str) str2=g_string_new("EM");
	else if(Compgstr(str,g_string_new("bold")))
	  str2=g_string_new("B");
	else if(Compgstr(str,g_string_new("italic")))
	  str2=g_string_new("I");
	else if(Compgstr(str,g_string_new("truetype")))
	  str2=g_string_new("TT"); 
	else str2=g_string_new("EM");
	printf("<%s>",str2->str);
	ids=trata_id_html(hash,ids,el->nlinha);
	travessia_Html(filho,ids);
	printf("</%s>",str2->str);
	g_string_free(str2,TRUE);
	if (str) g_string_free(str,TRUE);
      }
      break;
    case REF:
      {
	GString *str;
	ids=trata_id_html(hash,ids,el->nlinha);
	str=g_hash_table_lookup(hash,g_string_new("url"));
	if(str) printf("<A HREF=\"%s\">%s</A>",str->str,str->str);
	else {
	  str=g_hash_table_lookup(hash,g_string_new("email"));
	  if(str) printf("<A HREF=\"mailto:%s\">%s</A>",str->str,str->str);
	  else {
	    str=g_hash_table_lookup(hash,g_string_new("idref"));
	    if(str) {
	      printf("<A HREF=\"#%s\">%s</A>",str->str,str->str);
	      if (!g_hash_table_lookup(ids,str))
		{
		  int *i;
		  i=(int*)malloc(sizeof(int));
		  *i=-el->nlinha;
		  g_hash_table_insert(ids,g_string_new(str->str),i);
		}
	    }
	  }
	}
	if (str) g_string_free(str,TRUE);
      }
      break;
    case GRAFICO:
      {
	GString *str;
	str=g_hash_table_lookup(hash,g_string_new("local"));
	printf("<IMG SRC=\"%s\">\n",str->str);
	g_string_free(str,TRUE);
      }
      ids=trata_id_html(hash,ids,el->nlinha);
      break;
    case CODPROGRAMA:
      ids=trata_id_html(hash,ids,el->nlinha);
      printf("<PRE>\n");
      {
	GString* s;
	s=Elem_texto_get(filho);
	printf("%s",s->str);
	g_string_free(s,TRUE);
      }
      printf("</PRE>\n");
      break;
    case LISTA:
      {
	GString *str;
	str=g_hash_table_lookup(hash,g_string_new("tipo"));
	if (str && Compgstr(g_string_down(str),g_string_new("numerada"))) {
	  printf("<OL>\n");
	  ids=trata_id_html(hash,ids,el->nlinha);
	  travessia_Html(filho,ids);
	  printf("</OL>\n");
	} else {
	  printf("<UL>\n");
	  ids=trata_id_html(hash,ids,el->nlinha);
	  travessia_Html(filho,ids);
	  printf("</UL>\n");
	}
      }
      break;
    case ITEM:
      printf("<LI>\n");
      ids=trata_id_html(hash,ids,el->nlinha);
      travessia_Html(filho,ids);
      printf("</LI>\n");
      break;
    case EXEMPLO:
      ids=trata_id_html(hash,ids,el->nlinha);
      printf("<B>Exemplo:</B>");
      {
	int t;
	t=HTMLF.TamTitulo;
	HTMLF.TamTitulo=6;
	travessia_Html(filho,ids);
	HTMLF.TamTitulo=t;
      }
      break;
    case FECHO:
      printf("<HR>\n");
      ids=trata_id_html(hash,ids,el->nlinha);
      travessia_Html(filho,ids);
      break;
    case AGRADECIMENTOS:
      ids=trata_id_html(hash,ids,el->nlinha);
      printf("<B>Agradecimentos:</B>\n");
      travessia_Html(filho,ids);
      break;
    case BIBLIOGRAFIA:
      ids=trata_id_html(hash,ids,el->nlinha);
      printf("<B>Bibliografia:</B><UL>\n");
      travessia_Html(filho,ids);
      printf("</UL>\n");
      break;
    case BIBITEM:
      ids=trata_id_html(hash,ids,el->nlinha);
      printf("<LI>\n");
      travessia_Html(filho,ids);
      printf("</LI>\n");
      break;
    case CHAVE:
      ids=trata_id_html(hash,ids,el->nlinha);
      printf("[<I>");
      travessia_Html(filho,ids);
      printf("</I>]");
      break;
    case CORPO:
      ids=trata_id_html(hash,ids,el->nlinha);
      travessia_Html(filho,ids);
      printf("</BODY>\n");
      break;
    case CAPITULO:
      printf("<A NAME=\"_indice%d\">",HTMLF.IndiceCount++);
      ids=trata_id_html(hash,ids,el->nlinha);
      printf("<HR>\n");
      travessia_Html(filho,ids);
      break;
    case SECCAO:
      ++HTMLF.TamTitulo;
      printf("<A NAME=\"_indice%d\">",HTMLF.IndiceCount++);
      ids=trata_id_html(hash,ids,el->nlinha);
      travessia_Html(filho,ids);
      --HTMLF.TamTitulo;
      break;
    case PARA:
      ids=trata_id_html(hash,ids,el->nlinha);
      printf("<P>\n");
      travessia_Html(filho,ids);
      printf("</P>\n");
      break;
    case COMANDO:
      ids=trata_id_html(hash,ids,el->nlinha);
      printf("<TT>\n");
      travessia_Html(filho,ids);
      printf("</TT>\n");
      break;
    case PUB:
      ids=trata_id_html(hash,ids,el->nlinha);
      travessia_Html(filho,ids);
      break;
    case FIGURA:
      ids=trata_id_html(hash,ids,el->nlinha);
      printf("<B>Figura:</B>");
      {
	int t;
	t=HTMLF.TamTitulo;
	HTMLF.TamTitulo=6;
	travessia_Html(filho,ids);
	HTMLF.TamTitulo=t;
      }
      break;
    default:
    }
}

