%{ 
#include <glib.h>
#include <string.h>
#include "grove.h"
#include "gramatica.tab.h"


extern int nlines;

  GString* str;
  
  int conta(char* line) {
    char* a;
    int c=0;
    a=line;
    while(*line)
      {
	if(*line=='\n') c++;
	line++;
      }
    return c;
  }
%}



%x TAG ATRIB
%%

\<                          { if (str)
                              {
				yylval.gstr=str;
				str=NULL;
				unput ('<');
				return texto;
				
                              }
                              else {
				BEGIN(TAG); return *yytext;
			      }
                            }

<ATRIB,TAG>\>[ \n\t\r]*\<   { BEGIN(0); nlines+=conta(yytext); 
                              unput('<'); return *yytext; }

<ATRIB,TAG>\>[ \n\t\r]*$    { nlines+=conta(yytext); BEGIN(0); return *yytext;}

<ATRIB,TAG>\>               { BEGIN(0); return *yytext; }

<ATRIB>\=                   { return *yytext; }

<ATRIB>\"[^\"]*\"           { yylval.str=strdup(yytext);return valor; }

<ATRIB,TAG>\/               { return *yytext; }

<ATRIB>[A-Za-z][A-Za-z0-9]* { yylval.str=strdup(yytext);return id; }

<TAG,ATRIB>[ \t\r]+           ;

<TAG,ATRIB>[\n]             { nlines++; } 

<TAG>PLI-DOC                { BEGIN(ATRIB); return PLI_DOC; }
<TAG>ABERTURA               { BEGIN(ATRIB); return ABERTURA; }
<TAG>TITULO                 { BEGIN(ATRIB); return TITULO; }
<TAG>DATA                   { BEGIN(ATRIB); return DATA; }
<TAG>AUTOR                  { BEGIN(ATRIB); return AUTOR; }
<TAG>NOME                   { BEGIN(ATRIB); return NOME; }
<TAG>EMAIL                  { BEGIN(ATRIB); return EMAIL; }
<TAG>URL                    { BEGIN(ATRIB); return URL; }
<TAG>RESUMO                 { BEGIN(ATRIB); return RESUMO; }
<TAG>CORPO                  { BEGIN(ATRIB); return CORPO; }
<TAG>SECCAO		    { BEGIN(ATRIB); return SECCAO; }
<TAG>CAPITULO               { BEGIN(ATRIB); return CAPITULO; }
<TAG>PARA                   { BEGIN(ATRIB); return PARA; }
<TAG>LISTA                  { BEGIN(ATRIB); return LISTA; }
<TAG>ITEM                   { BEGIN(ATRIB); return ITEM; }
<TAG>REF                    { BEGIN(ATRIB); return REF; }
<TAG>REALCADO               { BEGIN(ATRIB); return REALCADO; }
<TAG>COMANDO                { BEGIN(ATRIB); return COMANDO; }
<TAG>FIGURA                 { BEGIN(ATRIB); return FIGURA; }
<TAG>GRAFICO                { BEGIN(ATRIB); return GRAFICO; }
<TAG>EXEMPLO                { BEGIN(ATRIB); return EXEMPLO; }
<TAG>FECHO                  { BEGIN(ATRIB); return FECHO; }
<TAG>AGRADECIMENTOS         { BEGIN(ATRIB); return AGRADECIMENTOS; }
<TAG>BIBLIOGRAFIA           { BEGIN(ATRIB); return BIBLIOGRAFIA; }
<TAG>BIBITEM                { BEGIN(ATRIB); return BIBITEM; }
<TAG>CHAVE                  { BEGIN(ATRIB); return CHAVE; }
<TAG>PUB                    { BEGIN(ATRIB); return PUB; }
<TAG>CODPROGRAMA            { BEGIN(ATRIB); return CODPROGRAMA; }

<TAG,ATRIB>. {printf("Erro: caracter esquisito na linha %d:%s\n",nlines,yytext); exit(1);}

[^<]{1,128}                 { nlines+=conta(yytext);
                              if (!str) str=g_string_new("");
			      str = g_string_append(str,yytext);
                            } 

%%


